/////////////////////////////////////////////////////////////////////////////
//
// Undelete
//
// Copyright (C) 1998 Mark Russinovich and Bryce Cogswell
// Systems Internals - http://www.sysinternals.com
//
// See readme.txt for terms of use.
//
/////////////////////////////////////////////////////////////////////////////

//
// InfoEntry.cpp: implementation of the InfoEntry class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Undelete.h"
#include "InfoEntry.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CInfoEntry::CInfoEntry()
{

}

CInfoEntry::~CInfoEntry()
{

}

CInfoEntry::CInfoEntry( DWORD FileId, CString Name, CString DeletedName, 
					   CString Type, LARGE_INTEGER TimeDeleted, DWORD Size)
{
	int		taildot = Name.ReverseFind( _T('.'));
	int		tailslash = Name.ReverseFind(_T('\\'));
	FILETIME	localTime;
	SYSTEMTIME	systemTime;
	char	timeBuf[64], dateBuf[64], sizeBuf[64];
	char	timeDateBuf[128];
	CFile	deletedFile;

	m_Name = tailslash != -1 ? Name.Right( Name.GetLength() - tailslash - 1 ) : 
					Name;
	m_FileId = FileId;
	m_OriginalName = Name;
	m_TimeDeleted = TimeDeleted;
	m_Size = Size;
	m_DeletedName = DeletedName;
	m_Type = Type;

	// set time string 
	FileTimeToLocalFileTime( (PFILETIME) &TimeDeleted, &localTime );
	FileTimeToSystemTime( &localTime, &systemTime );

	GetDateFormat( LOCALE_USER_DEFAULT, 0, &systemTime, NULL,
					dateBuf, sizeof(dateBuf));
	GetTimeFormat( LOCALE_USER_DEFAULT, 0,
					&systemTime, NULL, timeBuf, sizeof(timeBuf) );
	sprintf( timeDateBuf, "%s %s", dateBuf, timeBuf );
	m_TimeDeletedString = timeDateBuf;

	// get the file size
	if( deletedFile.Open( m_DeletedName, CFile::modeRead )) {

		m_Size = deletedFile.GetLength();
		sprintf( sizeBuf, _T("%dKB"), (m_Size+1023)/1024);
		m_SizeString = sizeBuf;

		// no icon
		m_Icon = NULL;
		m_ImageList = NULL; 

		// get the file status information
		deletedFile.GetStatus( m_FileStatus );

		// set time created string
		FileTimeToLocalFileTime( (PFILETIME) &m_FileStatus.m_ctime, &localTime );
		FileTimeToSystemTime( &localTime, &systemTime );

		GetDateFormat( LOCALE_USER_DEFAULT, 0, &systemTime, NULL,
						dateBuf, sizeof(dateBuf));
		GetTimeFormat( LOCALE_USER_DEFAULT, 0,
						&systemTime, NULL, timeBuf, sizeof(timeBuf) );
		sprintf( timeDateBuf, "%s %s", dateBuf, timeBuf );
		m_TimeCreatedString = timeDateBuf;

		deletedFile.Close();

	} else {

		m_FileId = (DWORD) -1;
	}
}

BOOL CInfoEntry::GetIcon()
{
	SHFILEINFO  shfi;

	// get icon
	if( m_ImageList ) return TRUE;

	m_ImageList = (HIMAGELIST) SHGetFileInfo(
				  (LPCSTR) m_DeletedName, 
				  0,
				  &shfi,
				  sizeof (SHFILEINFO),
				  SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
	if (m_ImageList)
	{
		m_Icon = shfi.iIcon;
		return TRUE;
	} else {

		return FALSE;
	}
}
