/////////////////////////////////////////////////////////////////////////////
//
// Undelete
//
// Copyright (C) 1998 Mark Russinovich and Bryce Cogswell
// Systems Internals - http://www.sysinternals.com
//
// See readme.txt for terms of use.
//
/////////////////////////////////////////////////////////////////////////////


class CUndeleteView : public CListViewEx
{
protected: // create from serialization only
	CUndeleteView();
	DECLARE_DYNCREATE(CUndeleteView)

// Attributes
public:
	CUndeleteDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CUndeleteView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CUndeleteView();
	virtual void DeleteSelectedEntries( BOOL Prompt, BOOL DisableRedraw );
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CUndeleteView)
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnDestroy();
	afx_msg void OnDelete();
	afx_msg void OnEmptybin();
	afx_msg void OnUndelete();
	afx_msg void OnRefresh();
	afx_msg void OnProperties();
	afx_msg void OnExclude();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnFileProperties();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// list view image lists
protected:
	CImageList m_SmallImageList;

// view type helpers
public:
	VOID UpdateStatusBar();
	CStringList m_DirectoryFilters;
	CStringList m_ExtensionFilters;
	CString m_ValidDriveLabel[26];
	DWORD m_ValidDriveSize[26];
	VOID ApplyGlobal( CPropSh *pGlobalPage );
	BOOL m_PromptOnAction;
	PURGE_INFORMATION m_Properties;
	virtual VOID SelectionChanged( DWORD TotalSelected );
	virtual VOID ActionSelectedEntries();
	BOOL SetViewType(DWORD dwViewType);
	DWORD GetViewType();
	void ReadBins( BOOLEAN RedrawListView );
	CMutex m_Mutex;
	CString m_GlobalRegistryKey;
	CString m_LocalRegistryKey;


// flags and states
protected:
	LPTSTR m_TextualSid;
	int m_nCheckedItem;
	HICON m_hSmallIcon;
	HICON m_hLargeIcon;
	static int CALLBACK CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort );
	BOOL GetTextualSID( VOID );
};

#ifndef _DEBUG  // debug version in RListVw.cpp
inline CUndeleteDoc* CUndeleteView::GetDocument()
   { return (CUndeleteDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
